var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/schema-utils.ts
var schema_utils_exports = {};
__export(schema_utils_exports, {
  ajv: () => ajv,
  validateDataAgainstSchema: () => validateDataAgainstSchema,
  validateSchema: () => validateSchema,
  validateSchemaAndAssignDefaults: () => validateSchemaAndAssignDefaults
});
module.exports = __toCommonJS(schema_utils_exports);
var import_ajv = __toESM(require("ajv"));
var import_typeof = __toESM(require("ajv-keywords/keywords/typeof.js"));
var ajv = new import_ajv.default();
(0, import_typeof.default)(ajv);
var ajvDefaults = new import_ajv.default({
  useDefaults: true
});
function validateSchema(schema) {
  const isSchemaValid = ajv.validateSchema(schema);
  return {
    ok: isSchemaValid,
    message: isSchemaValid ? "" : `Schema itself is not valid. ${ajv.errorsText()}`
  };
}
__name(validateSchema, "validateSchema");
function validateSchemaAndAssignDefaults(schema, data) {
  const { ok, message } = validateSchema(schema);
  if (!ok) {
    return {
      ok: false,
      message,
      data
    };
  }
  const newData = { ...data };
  const isValid = !!ajvDefaults.validate(schema, newData);
  return {
    ok: isValid,
    message: isValid ? "" : ajvDefaults.errorsText(),
    data: newData
  };
}
__name(validateSchemaAndAssignDefaults, "validateSchemaAndAssignDefaults");
function validateDataAgainstSchema(schema, data) {
  const { ok, message } = validateSchema(schema);
  if (!ok) {
    return {
      ok: false,
      message
    };
  }
  const isValid = !!ajv.validate(schema, data);
  return {
    ok: isValid,
    message: isValid ? "" : ajv.errorsText(),
    errors: isValid ? [] : ajv.errors
  };
}
__name(validateDataAgainstSchema, "validateDataAgainstSchema");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ajv,
  validateDataAgainstSchema,
  validateSchema,
  validateSchemaAndAssignDefaults
});
//# sourceMappingURL=schema-utils.js.map